# -*- coding: utf-8 -*-
# Ett exempel med layout-hanteraren "place"
# Löst med separat klass för grafiken,
# detta för att återanvända koden från lösning utan grafik.

import math
from tkinter import *

G = 6.67*math.pow(10,-11)
Mjordklotet = 5.977*math.pow(10,24)
W = 100
H = 20
BG = '#a1d490'

class Graphics:

    def __init__(self):
        self.root = Tk()
        self.root.geometry('480x300+0+0')
        self.root.resizable(0,0)
        self.root.configure(bg='#d4a190') #configure metod för många komponenter
        self.root.title('centralkroppmassor')


        self.rubrik = Label(self.root, anchor='w', font='Arial 8 bold', bg=BG, text = 'Centralkropp')
        self.rubrik.place(x =  20, y = 20, width=W-1, height=H)
        self.rubrik = Label(self.root, anchor='e', font='Arial 8 bold', bg=BG, text = 'm'+chr(9793))
        self.rubrik.place(x =  120, y = 20, width=W-1, height=H)
        self.rubrik = Label(self.root, anchor='e', font='Arial 8 bold', bg = BG, text = ''+chr(963))
        self.rubrik.place(x =  220, y = 20, width=W-1, height=H)
        self.rubrik = Label(self.root,anchor='e', font='Arial 8 bold', bg = BG, text = 'Antal satelliter')
        self.rubrik.place(x =  320, y = 20, width=W-1, height=H)


        self.button_help = Button(self.root, text='Hjälp', font='Arial 10 bold', bg = BG, command = self.help)
        self.button_help.place(x =  20, y = 200, width=W-1, height=20)
        self.button_load = Button(self.root, text='Läs', font='Arial 10 bold', bg = BG, command=self.load)
        self.button_load.place(x = 120, y = 200, width=W-1, height=20)
        self.button_clear = Button(self.root, text='Rensa', font='Arial 10 bold', bg = BG, command=self.clear)
        self.button_clear.place(x = 220, y = 200, width=W-1, height=20)
        self.button_exit = Button(self.root, text='Avsluta', font='Arial 10 bold', bg = BG, command=self.exit)
        self.button_exit.place(x = 320, y = 200, width=W-1, height=20)

        self.message = Label(self.root, anchor='e', font='Arial 8', bg='#ffffff', text = '')
        self.message.place(x =  20, y = 240, width=W*4, height=H*2)
        self.root.mainloop()
        
    def help(self):
        s = 'Här kan du för ett godtyckligt astronomiskt objekt beräkna dess massa,\n'
        s+= 'kravet är att objektet har minst en satellit vilken du måste känna\n'
        s+= 'till avståndet och omloppstiden för. Se filen infil.txt'
        self.message.configure(anchor='w', justify='left', text=s)        

    def load(self):
        himlakropparna = lasFranFil()
        self.m=list()
        for i in range(len(himlakropparna)):
            
            kol = list()
            e = Label(self.root, anchor='w',text = str(himlakropparna[i].namn))
            kol.append(e)
            kol[0].place(x =  20, y = 40 + i*H, width=W-1, height=H-1)

            e = Label(self.root, anchor='e', text = str(round(himlakropparna[i].mm()/Mjordklotet)))
            kol.append(e)
            kol[1].place(x =  120, y = 40 + i*H, width=W-1, height=H-1)

            e = Label(self.root, anchor='e', text = str(round(himlakropparna[i].stav()/Mjordklotet,1)))
            kol.append(e)
            kol[2].place(x = 220, y = 40 + i*H, width=W-1, height=H-1)

            e = Label(self.root, anchor='e', text = str(len(himlakropparna[i].satelliter)))
            kol.append(e)
            kol[3].place(x = 320, y = 40 + i*H, width=W-1, height=H-1)


            self.m.append(kol)
            
    def clear(self):
        self.message.configure(width=W*4, height=20, anchor='w', justify='left', text='')  

    def exit(self):
        self.root.destroy()
        

class Satellit:

    def __init__(self, r, T):
        self.r = r # r är avstånd
        self.T = T # T är omloppstid
        self.massa = 4*math.pow(math.pi,2)*math.pow(self.r*1000000,3)/(G*math.pow(self.T*3600,2))
        
class Himlakropp:
    def __init__(self, namn):
        self.namn = namn
        self.satelliter = list()

    def adderaSatellit(self, s):
        self.satelliter.append(s)

    # Beräknar medelmassan
    def mm(self):
        summa = 0
        for s in self.satelliter:
            summa += s.massa
        return summa / len(self.satelliter)

    # Beräknar standardavvikelsen
    def stav(self):
        summa = 0
        for s in self.satelliter:
            summa += math.pow((s.massa-self.mm()),2)
        if len(self.satelliter)==1:
            return 0
        else:
            return math.sqrt(summa/len(self.satelliter)-1)


# Metod som läser in från filen till listan himlakropparna
def lasFranFil():
    infil = open('infil.txt','r')
    rad = ""
    infil.readline() # slurpa slaskrad1
    infil.readline() # slurpa slaskrad2
    infil.readline() # slurpa slaskrad3
    infil.readline() # slurpa slaskrad4
    namn = infil.readline().rstrip('\n')
    himlakropparna = list()
    while (namn != ''):
        hk = Himlakropp(namn)
        himlakropparna.append(hk)
        rad = infil.readline().rstrip('\n')
        while (rad.isalpha() == False) and (rad != ''):
            delar = rad.split('/') # För att ta bort "/" tecknet
            r = float(delar[0])
            T = float(delar[1])
            hk.adderaSatellit(Satellit(r,T))
            rad = infil.readline().rstrip('\n')
        namn = rad
    return himlakropparna
        
# Här följer huvudprogrammet

himlakropparna = lasFranFil()
g = Graphics()
